<?php
namespace Incoviba\Common\Controller;

use Psr\Http\Message\ServerRequestInterface as Request;
use Psr\Http\Message\ResponseInterface as Response;
use \Model;
use Incoviba\Common\Define\Controller\Json;
use Incoviba\Proyecto;

class Proyectos {
  use Json;

  public function __invoke(Request $request, Response $response): Response {
    $proyectos = Model::factory(Proyecto::class)->order_by_asc('descripcion')->find_many();
    array_walk($proyectos, function(&$item) {
      $item = $item->as_array();
    });
    $output = compact('proyectos');
    return $this->withJson($response, $output);
  }
  public function show(Request $request, Response $response, $id_proyecto): Response {
    $proyecto = Model::factory(Proyecto::class)->find_one($id_proyecto);
    $output = ['proyecto' => null];
    if ($proyecto) {
      $output = ['proyecto' => $proyecto->as_array()];
    }
    return $this->withJson($response, $output);
  }
  public function ventas(Request $request, Response $response, $id_proyecto): Response {
    $proyecto = Model::factory(Proyecto::class)->find_one($id_proyecto);
    $ventas = $proyecto->ventas();
    usort($ventas, function($a, $b) {
      return strcmp(str_pad($a->propiedad()->unidades()[0]->descripcion, 4, '0', \STR_PAD_LEFT), str_pad($b->propiedad()->unidades()[0]->descripcion, 4, '0', \STR_PAD_LEFT));
    });
    $output = [
      'proyecto' => $proyecto->as_array(),
      'ventas' => array_map(function($item) {
        if ($item) {
          return $item->as_array();
        }
      }, $ventas)
    ];
    return $this->withJson($response, $output);
  }
  public function operadores(Request $request, Response $response, $id_proyecto): Response {
    $proyecto = Model::factory(Proyecto::class)->find_one($id_proyecto);
    $output = [
      'proyecto' => $proyecto->as_array(),
      'operadores' => $proyecto->operadores() ? array_map(function($item) {
        if ($item) {
          return $item->as_array();
        }
      }, $proyecto->operadores()) : null
    ];
    return $this->withJson($response, $output);
  }
}
